%% MODEL 700 is Model 6 with real wage growth;

%MODEL SPECIFICATIONS
mspec=904;
subspec=9;
pf_mod='54';
dataset=700;

paramDate = 2008.50;
peachfile='peachdata_2012_04_17';

bolUseFinals=1; % in sample fit

% aux variables
auxFlag=1;
%saveSemiCondStShFlag = 1;
useRtParallelResults = 0;

ovint=86; % in sample fit

%OOS specific settings
OOS='FULL';
fmean=1;

PLOTDRAWS=0;
lastvint=0;
vcov=0;

judge='BC';

compound=0;

first=0;

qahead=40;

nantmax=2;  % use prespecified nant, antlags & OIS

nant=7; % GR forecast w/ zerobound (nantmax=3)

antlags=15;
antlags=14; % For hardconditioning w/ ZLB

dsge=1;
gbook=1;
bluechip=0;
roch=1;

%vindex=[59];
qvint=1;

%dates=2011;
%stime=[];%111;
mnobss=16; % full sample, 2008.5
% mnobss=22; % full sample, 2007
% mnobss = 18; % GR
REMAX_MODE=1;

%SAVE SETTINGS
overwrite = 1;


%FORECAST SETTINGS
zerobound = 0; % no zb
% zerobound = 1; % zb
bdd_int_rate = 0;

dsflag = 0;
peachflag = 0; % uncond
% peachflag = 1; % semicond

simple_forecast = 0;


%NEWSLETTER SETTINGS
issue_num=10;

newsletter = 0;
system = 0;
pres = 1;

useSavedMB = 0;


%PARALLEL SETTINGS
%parallelflag = 1;
%parflag = 1;
distr=1;
nMaxWorkers=20;